'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.bindToEndpoint = bindToEndpoint;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _DataSourceActionsJs = require('./DataSourceActions.js');

/**
 * This function provides simple binding to an API endpoint.
 * It also injects the "update" function into the child component's props.
 * This is how we can automate the whole data lifecycle.
 */

function bindToEndpoint(endpoint) {
    var url = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];

    function mapStateToProps(state) {
        return {
            data: state.dataSources[endpoint] ? state.dataSources[endpoint].data : [],
            meta: state.dataSources[endpoint] ? state.dataSources[endpoint].meta : {},
            params: state.dataSources[endpoint] ? state.dataSources[endpoint].params : {}
        };
    }

    return function (ListComponent) {
        return (0, _reactRedux.connect)(mapStateToProps)(_react2['default'].createClass({
            componentDidMount: function componentDidMount() {
                /** TODO: Find a better way to do this that doesn't require the component to mount first. */
                this.update();
            },

            update: function update() {
                var params = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

                this.props.dispatch((0, _DataSourceActionsJs.updateDataSource)(endpoint, params, url));
            },

            render: function render() {
                return _react2['default'].createElement(ListComponent, _extends({}, this.props, { update: this.update }));
            }
        }));
    };
}

exports['default'] = bindToEndpoint;