'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = dataSources;

var _DataSourceActionsJs = require('./DataSourceActions.js');

var initialDataSourceState = {
    isFetching: false
};

function dataSources(state, action) {
    if (state === undefined) state = initialDataSourceState;

    switch (action.type) {
        case _DataSourceActionsJs.DATASOURCE_REQUEST:
            return _extends({}, state, {
                isFetching: true
            });

        case _DataSourceActionsJs.DATASOURCE_RESPONSE:
            var newState = {
                isFetching: false
            };

            newState[action.path] = {
                data: action.data,
                meta: action.meta,
                params: action.params
            };

            return _extends({}, state, newState);
    }

    return state;
}

module.exports = exports['default'];