'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PaginationJs = require('./Pagination.js');

var _PaginationJs2 = _interopRequireDefault(_PaginationJs);

function ListView(title, Header, Row) {
    var pageSize = arguments.length <= 3 || arguments[3] === undefined ? 10 : arguments[3];

    var View = _react2['default'].createClass({
        displayName: 'View',

        getPagination: function getPagination() {
            if (pageSize) {
                return _react2['default'].createElement(
                    'tfoot',
                    null,
                    _react2['default'].createElement(
                        'tr',
                        null,
                        _react2['default'].createElement(
                            'td',
                            { colspan: '100' },
                            _react2['default'].createElement(_PaginationJs2['default'], { total: this.props.meta ? this.props.meta.total : 0, pageSize: pageSize, currentPage: this.props.params ? this.props.params.page : 0, update: this.props.update })
                        )
                    )
                );
            }

            return '';
        },

        render: function render() {
            var pagination = this.getPagination();

            return _react2['default'].createElement(
                'table',
                { className: 'col-lg-12 table table-striped table-hover' },
                _react2['default'].createElement(
                    'thead',
                    null,
                    _react2['default'].createElement(Header, null)
                ),
                _react2['default'].createElement(
                    'tbody',
                    null,
                    this.props.data.map(function (row, index) {
                        return _react2['default'].createElement(Row, { data: row, key: index });
                    })
                ),
                pagination
            );
        }
    });

    return View;
}

ListView.propTypes = {
    data: _react.PropTypes.array.isRequired,
    meta: _react.PropTypes.object.isRequired,
    params: _react.PropTypes.object.isRequired,
    update: _react.PropTypes.func.isRequired
};

exports['default'] = ListView;
module.exports = exports['default'];