import React, { Component, PropTypes } from 'react';
import { connect } from 'react-redux';
import { updateDataSource } from './DataSourceActions.js';

/**
 * This function provides simple binding to an API endpoint.
 * It also injects the "update" function into the child component's props.
 * This is how we can automate the whole data lifecycle.
 */
export function bindToEndpoint(endpoint, url = '') {
    function mapStateToProps(state) {
        return {
            data: state.dataSources[endpoint] ? state.dataSources[endpoint].data : [],
            meta: state.dataSources[endpoint] ? state.dataSources[endpoint].meta : {},
            params: state.dataSources[endpoint] ? state.dataSources[endpoint].params : {}
        };
    }

    return function(ListComponent) {
        return connect(mapStateToProps)(React.createClass({
            componentDidMount() {
                /** TODO: Find a better way to do this that doesn't require the component to mount first. */
                this.update();
            },

            update(params = {}) {
                this.props.dispatch(updateDataSource(endpoint, params, url));
            },

            render() {
                return (
                    <ListComponent {...this.props} update={this.update} />
                );
            }
        }));
    }
}

export default bindToEndpoint;