import { DATASOURCE_REQUEST, DATASOURCE_RESPONSE } from './DataSourceActions.js';

const initialDataSourceState = {
    isFetching: false
};

export default function dataSources(state = initialDataSourceState, action) {
    switch(action.type) {
        case DATASOURCE_REQUEST:
            return Object.assign({}, state, {
                isFetching: true
            });

        case DATASOURCE_RESPONSE:
            let newState = {
                isFetching: false
            };

            newState[action.path] = {
                data: action.data,
                meta: action.meta,
                params: action.params
            };

            return Object.assign({}, state, newState);
    }

    return state;
}