import React, { Component, PropTypes } from 'react';
import Pagination from './Pagination.js';

function ListView(title, Header, Row, pageSize = 10) {
    const View = React.createClass({
        getPagination() {
            if (pageSize) {
                return (
                    <tfoot>
                        <tr>
                            <td colspan="100">
                                <Pagination total={ this.props.meta ? this.props.meta.total : 0 } pageSize={pageSize} currentPage={ this.props.params ? this.props.params.page : 0 } update={ this.props.update } />
                            </td>
                        </tr>
                    </tfoot>
                );
            }

            return '';
        },

        render() {
            let pagination = this.getPagination();

            return (
                <table className="col-lg-12 table table-striped table-hover">
                    <thead>
                        <Header />
                    </thead>
                    <tbody>
                        { this.props.data.map((row, index) => (
                            <Row data={row} key={index} />
                        ))}
                    </tbody>
                    { pagination }
                </table>
            );
        }
    });

    return View;
}

ListView.propTypes = {
    data: PropTypes.array.isRequired,
    meta: PropTypes.object.isRequired,
    params: PropTypes.object.isRequired,
    update: PropTypes.func.isRequired
};

export default ListView;