import React, { Component, PropTypes } from 'react';

class Pagination extends Component {

    getPageNumber() {
        if (this.props.currentPage) {
            return this.props.currentPage;
        }
        return 1;
    }

    previous() {
        let pageNumber = this.getPageNumber();

        if (pageNumber == 1) {
            return {
                page: 1,
                pageSize: this.props.pageSize
            }
        }

        return {
            page: pageNumber - 1,
            pageSize: this.props.pageSize
        }
    }

    next() {
        let pageNumber = this.getPageNumber();

        if (pageNumber * this.props.pageSize > this.props.total) {
            return {
                page: pageNumber,
                pageSize: this.props.pageSize
            }
        }

        return {
            page: pageNumber + 1,
            pageSize: this.props.pageSize
        }
    }

    render() {
        return (
            <div className="wrapper border-top white-bg page-heading p-l-10">
                <div className="btn-group pagination">
                    <a onClick={ () => this.props.update(this.previous())} className="btn btn-white">
                        <i className="fa fa-chevron-left"></i>
                    </a>
                    <a onClick={ () => this.props.update(this.next())} className="btn btn-white">
                        <i className="fa fa-chevron-right"></i>
                    </a>
                </div>
            </div>
        );
    }
}

Pagination.propTypes = {
    total: PropTypes.number,
    pageSize: PropTypes.number,
    currentPage: PropTypes.number,
    update: PropTypes.func.isRequired
};


export default Pagination;